/*
 * StateNonterminalMap.h
 *
 *  Created on: 15. 3. 2014
 *      Author: tomas
 */

#ifndef STATENONTERMINALMAP_H_
#define STATENONTERMINALMAP_H_

#include <map>

#include <automaton/FSM/FSM.h>
#include <grammar/Regular/RegularGrammar.h>
#include <AlibException.h>

#include "../include/macros.h"

namespace conversions
{

class StateNonterminalMap
{
public:
    StateNonterminalMap( const automaton::FSM & fsm, grammar::RegularGrammar & grammar );
    const alphabet::Symbol & getNonTerminal( const automaton::State & state );

private:
    void initMap( void );

    /**
     * Maps automaton's state to grammar's Symbol
     */
    std::map<const automaton::State, const alphabet::Symbol> m_map;

    const automaton::FSM & m_fsm;
    grammar::RegularGrammar & m_grammar;

};

} /* namespace conversions */

#endif /* STATENONTERMINALMAP_H_ */
