/*
 * LeftToRightRegularGrammar.cpp
 *
 *  Created on: 8. 3. 2014
 *      Author: tomas
 */

#include "LeftToRightRegularGrammar.h"

using namespace alphabet;
using namespace grammar;
using namespace std;

namespace conversions
{

LeftToRightRegularGrammar::LeftToRightRegularGrammar( const grammar::LeftRegularGrammar & lrg ) : AbstractLRGtoRRGConverter( lrg )
{

}

LeftToRightRegularGrammar::~LeftToRightRegularGrammar( void )
{

}

RightRegularGrammar LeftToRightRegularGrammar::convert( void )
{
    for( const auto & symbol : m_lrg.getNonTerminalSymbols( ) )
        m_rrg.addNonTerminalSymbol( symbol );

    for( const auto & symbol : m_lrg.getTerminalSymbols( ) )
        m_rrg.addTerminalSymbol( symbol );

    // 1.
    Symbol s = m_rrg.createUniqueNonTerminalSymbol( m_lrg.getStartSymbol( ).getSymbol( ), false );
    m_rrg.setStartSymbol( s );

    // 2.
    for( const auto & rule : m_lrg.getRules( ) )
    {
        if( rule.getRightSide( ).size( ) == 2 )
        {
            list<Symbol> leftSide = { * rule.getRightSide( ).begin( ) };
            list<Symbol> rightSide = { * std::next( rule.getRightSide( ).begin( ) ), * rule.getLeftSide( ).begin( ) };
            m_rrg.addRule( Rule( leftSide, rightSide ) );

            if( * rule.getLeftSide( ).begin( ) == m_lrg.getStartSymbol( ) )
            {
                list<Symbol> leftSide = { * rule.getRightSide( ).begin( ) };
                list<Symbol> rightSide = { * std::next( rule.getRightSide( ).begin( ) ) };
                m_rrg.addRule( Rule( leftSide, rightSide ) );
            }
        }
        else if( rule.getRightSide( ).size( ) == 1 )
        {
            list<Symbol> leftSide = { m_rrg.getStartSymbol( ) };
            list<Symbol> rightSide = { * rule.getRightSide( ).begin( ), *rule.getLeftSide( ).begin( ) };
            m_rrg.addRule( Rule( leftSide, rightSide ) );

            if( * rule.getLeftSide( ).begin( ) == m_lrg.getStartSymbol( ) )
            {
                list<Symbol> leftSide = { m_rrg.getStartSymbol( ) };
                list<Symbol> rightSide = { * rule.getRightSide( ).begin( ) };
                m_rrg.addRule( Rule( leftSide, rightSide ) );
            }
        }
        else
        {
            // assert leftSide == rrg.getStartSymbol( )
            list<Symbol> leftSide = { m_rrg.getStartSymbol( ) };
            list<Symbol> rightSide;
            m_rrg.addRule( Rule( leftSide, rightSide) );
        }
    }

    return m_rrg;
}

} /* namespace conversions */
