/*
 * RRGAlgebraic.cpp
 *
 *  Created on: 4. 3. 2014
 *      Author: tomas
 */

#include "RRGAlgebraic.h"

using namespace alphabet;
using namespace grammar;
using namespace regexp;

namespace conversions
{

RRGAlgebraic::RRGAlgebraic( const RightRegularGrammar & rg ) : AbstractRRGtoREConverter( rg )
{

}

RRGAlgebraic::~RRGAlgebraic( void )
{

}

RegExp RRGAlgebraic::convert( void )
{
    for( const auto & symb : m_grammar.getNonTerminalSymbols( ) )
        m_solver.addSymbol( symb );

    for( const auto & rule : m_grammar.getRules( ) )
    {
        const Symbol & leftSide = * rule.getLeftSide( ).begin( );
        if( rule.getRightSide( ).size( ) == 0 )
        {
            m_solver.addEquation( leftSide, new RegExpEpsilon( ) );
        }
        else if( rule.getRightSide( ).size( ) == 1 )
        {
            const Symbol & input = * rule.getRightSide( ).begin( );
            m_solver.addEquation( leftSide, new RegExpSymbol( input.getSymbol( ) ) );
        }
        else
        {
            const Symbol input = * rule.getRightSide( ).begin( );
            const Symbol nt = * ( std::next( rule.getRightSide( ).begin( ) ) );
            m_solver.addEquation( leftSide, nt, new RegExpSymbol( input.getSymbol( ) ) );
        }
    }

    return m_solver.solve( m_grammar.getStartSymbol( ) );
}

} /* namespace conversions */
